#include "IdentiKit.h"

static HWND hListViewBIOS;
BIOSINFO rBiosInfo [] = {//array
	{TEXT("BIOS Vendor"), *achValue},
	{TEXT("BIOS Version"), TEXT("BL 0x0000000")},
	{TEXT("BIOS Release date"), TEXT("CL 0x0000000")},
	{TEXT("Base board manufacturer"), TEXT("Texto texto texto")},
	{TEXT("Base board product"), TEXT("Texto texto texto")},
	{TEXT("Base board version"), TEXT("Texto texto texto")},
	{TEXT("System manufacturer"), TEXT("Texto texto texto")},
	{TEXT("System family"), TEXT("Texto texto texto")},
	{TEXT("System product name"), TEXT("Texto texto texto")},
	{TEXT("System SKU"), TEXT("Texto texto texto")},
	{TEXT("System version"), TEXT("Texto texto texto")},
};

int WINAPI WinMain (HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)
{
    HWND hwnd;
    MSG messages;
    WNDCLASSEX wcx;
	HACCEL hAccelTable;
	INITCOMMONCONTROLSEX iccx;

	hInstance = hThisInstance;
#if !defined (__GNUC__)
	UNREFERENCED_PARAMETER (lpszArgument);
	UNREFERENCED_PARAMETER (hPrevInstance);
#endif
	iccx.dwICC = sizeof (INITCOMMONCONTROLSEX);
	iccx.dwSize = ICC_TAB_CLASSES;
	if (!InitCommonControlsEx (&iccx)) {
		MessageBox (HWND_DESKTOP, L"Error: No se pudieron cargar los controles comunes", L"", MB_OK | MB_ICONERROR);
		return 0;
	}

	LoadString (hThisInstance, IDS_CLASSNAME, tszClassName, MAX_BUFFER);
	LoadString (hThisInstance, IDS_APPTITLE, tszAppTitle, MAX_BUFFER);

    wcx.hInstance = hThisInstance;
    wcx.lpszClassName = tszClassName;
    wcx.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wcx.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wcx.cbSize = sizeof (WNDCLASSEX);
    wcx.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wcx.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wcx.hCursor = LoadCursor (NULL, IDC_ARROW);
    wcx.lpszMenuName = MAKEINTRESOURCE (IDM_MAINMENU);                 /* No menu */
    wcx.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wcx.cbWndExtra = 0;                      /* structure or the window instance */
	wcx.hbrBackground = (HBRUSH) COLOR_WINDOW;

    if (!RegisterClassEx (&wcx))
        return 0;
	
	hwnd = CreateWindowEx (0, tszClassName, tszAppTitle, WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
		CW_USEDEFAULT, CW_USEDEFAULT, 800, 500, HWND_DESKTOP, NULL, hThisInstance, NULL);
	if (!hwnd) {
		MessageBoxW (HWND_DESKTOP, L"Error: hwnd tuvo un fallo", L"", MB_OK | MB_ICONERROR);
		return 0;
	}

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);
	UpdateWindow (hwnd);
	hAccelTable = LoadAcceleratorsW (hInstance, MAKEINTRESOURCE (IDA_ACCELTABLE));

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
		if (!TranslateAcceleratorW (messages.hwnd, hAccelTable, &messages))
		{
			/* Translate virtual-key messages into character messages */
			TranslateMessage(&messages);
			/* Send message to WindowProcedure */
			DispatchMessage(&messages);
		}
	}
    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return (int)messages.wParam;
}

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
	/*  This function is called by the Windows function DispatchMessage()  */
{
	static HWND hTab;
	RECT rcClient;

	switch (message)                  /* handle the messages */
    {
		case WM_CREATE:
			GetClientRect (hwnd, &rcClient);
			hTab = CreateWindowExW (0, WC_TABCONTROL, NULL, WS_CHILD | WS_VISIBLE, 0, 0, 
				rcClient.right - rcClient.left - 20, rcClient.bottom - rcClient.top - 30,
				hwnd, (HMENU) ID_TABCTRL, hInstance, NULL);
			Wnd::Tab_InsertItem (hTab, L"Resumen", 0);
			Wnd::Tab_InsertItem (hTab, L"BIOS", 1);
			BiosInfo (hTab);
			break;
		case WM_SIZE:
		{
			static HWND hwndTabCtrl = GetDlgItem (hwnd, ID_TABCTRL);
			RECT rcClient, rcTab, rcLVBIOS;

			GetClientRect (hwnd, &rcClient);
			SendMessageW (hwndTabCtrl, TCM_ADJUSTRECT, 0, (LPARAM)&rcTab);
			SendMessageW (hListViewBIOS, WM_SIZE, 2, (LPARAM)&rcLVBIOS);
			SetWindowPos(hwndTabCtrl, NULL, 5, 5, rcClient.right-10, rcClient.bottom-10, SWP_DRAWFRAME | SWP_NOZORDER);
		}
		break;
		case WM_NOTIFY:
		{
			LPNMHDR lpnmhdr = (LPNMHDR) lParam;
			if (lpnmhdr->code == TCN_SELCHANGE)
			{
				INT nTabItem = TabCtrl_GetCurSel (hTab);
				switch (nTabItem)
				{
					case 0:
						Wnd::Hide (hListViewBIOS);
						break;
					case 1:
						Wnd::Show (hListViewBIOS);
						break;
					default:
						break;
				}
			}
			
			switch (((LPNMHDR) lParam)->code) 
            { 
                case LVN_GETDISPINFO: 
                    OnGetDispInfo((NMLVDISPINFO *) lParam); 
                    break; 
            }
			return 0;
		}
		break;
		case WM_CONTEXTMENU:
		{
			HMENU hcontextmenu = CreatePopupMenu();

			AppendMenu (hcontextmenu, MF_STRING, (UINT)CMD_HELP, L"&Temas de ayuda...\tF1");
			AppendMenu (hcontextmenu, MF_STRING, (UINT)CMD_ABOUT, L"Sobre este &programa...\t");
			AppendMenu (hcontextmenu, MF_SEPARATOR, 0, NULL);
			AppendMenu (hcontextmenu, MF_STRING, (UINT)CMD_QUIT, L"&Salir\tAlt+F4");
			TrackPopupMenuEx (hcontextmenu, TPM_LEFTALIGN | TPM_RIGHTBUTTON | TPM_HORIZONTAL | TPM_VERTICAL, 
				LOWORD (lParam), HIWORD (lParam), hwnd, NULL);
		}
		break;
		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
				case CMD_HELP:
					MessageBox (hwnd, L"Ayuda no disponible.", L"Ayuda", MB_OK);
					break;
				case CMD_ABOUT:
					MessageBox (hwnd, L"", L"(c) IdentiKit.\n", MB_OK);
					break;
				case CMD_QUIT:
					PostQuitMessage (0);
					break;
				default:
					return DefWindowProc (hwnd, message, wParam, lParam);
			}
			break;
        case WM_DESTROY:
            PostQuitMessage (0);
            break;
        default: 
            return DefWindowProc (hwnd, message, wParam, lParam);
    }
    return 0;
}

HWND __cdecl BiosInfo (HWND hwndParent)
{
	RECT rc;
	int index;
	LVITEM lvi;
	HICON hIcon;
	LVCOLUMN lvc;
	TCHAR szText [50];
	HIMAGELIST hSmall, hLarge;
	INITCOMMONCONTROLSEX iccx;

	iccx.dwSize = sizeof (iccx);
	iccx.dwICC = ICC_LISTVIEW_CLASSES;
	if (!InitCommonControlsEx (&iccx)) {
		MessageBox (hwndParent, L"Error: ICCX en ListView BIOS no inicializada",
			L"Error", MB_OK | MB_ICONERROR);
		return NULL;
	}

	GetClientRect (hwndParent, &rc);
	hListViewBIOS = CreateWindowExW (WS_EX_CLIENTEDGE, WC_LISTVIEW, NULL, WS_CHILD | WS_BORDER | WS_VSCROLL | 
		LVS_REPORT | LVS_ICON | LVS_NOSORTHEADER, 14, 32, rc.right - rc.left - 15, (rc.bottom - rc.top) -15, 
		hwndParent,  (HMENU)ID_LISTVIEW_BIOS, hInstance, NULL);
	if (!hListViewBIOS)
		return NULL;
	hSmall = ImageList_Create (16, 16, FALSE, 3, 0);
	hLarge = ImageList_Create (32, 32, FALSE, 3, 0);

	for(index = 500; index < 503; index++)    
	{
		hIcon = LoadIcon (hInstance, MAKEINTRESOURCE(index));
        ImageList_AddIcon (hSmall, hIcon);
		ImageList_AddIcon (hLarge, hIcon);
	}

	if(ImageList_GetImageCount(hSmall) < 3)
		return FALSE;
	if(ImageList_GetImageCount(hLarge) < 3)
		return FALSE;

	ListView_SetImageList(hListViewBIOS, hSmall, LVSIL_SMALL);
	ListView_SetImageList(hListViewBIOS, hLarge, LVSIL_NORMAL);

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvc.fmt = LVCFMT_LEFT;
	lvc.cx = 250;
	lvc.pszText = szText;

	for (index = 0; index < 2; index++)
	{
		lvc.iSubItem = index;
		LoadString(hInstance, IDS_BIOSPROPNAME + index, szText, sizeof(szText));
		if(ListView_InsertColumn(hListViewBIOS, index, &lvc) == -1)
			return NULL;
	}

	lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
	lvi.state = 0;
	lvi.stateMask = 0;
	
	for (index = 0; index < 11; index++)
	{
		lvi.iItem = index;
		lvi.iImage = index;
		lvi.iSubItem = 0;
		lvi.pszText = LPSTR_TEXTCALLBACK;

		if(ListView_InsertItem(hListViewBIOS, &lvi) == -1)
			return NULL;
	}

	return hListViewBIOS;
}

 VOID OnGetDispInfo(NMLVDISPINFO *plvdi) 
 {
  switch (plvdi->item.iSubItem)
    {

    case 0:
		plvdi->item.pszText = rBiosInfo[plvdi->item.iItem].szProperty;
      break;

    case 1:
		plvdi->item.pszText = rBiosInfo[plvdi->item.iItem].szValue;
      break;

    default:
      break;
    }
 } 

 int Wnd::Tab_InsertItem (HWND hTab, LPTSTR pszText, int id)
{
	TCITEM tci;

	tci.mask = TCIF_TEXT | TCIF_IMAGE;
	tci.pszText = pszText;
	tci.cchTextMax = (int)wcslen (pszText);
	tci.iImage = id;
	
	return (int) TabCtrl_InsertItem (hTab, id, &tci);
}

int Wnd::Show (HWND hwndParent)
{
	return ShowWindow (hwndParent, SW_SHOW);
}

int Wnd::Hide (HWND hwndParent)
{
	return ShowWindow (hwndParent, SW_HIDE);
}

LPWSTR IdentiKitLibrary::GetBIOSVendor ()
{
	cchValue = HKEY_MAX_VALUE_NAME; 
    achValue[0] = '\0'; 
	RegEnumValueW(HKEY_LOCAL_MACHINE, 0, achValue, &cchValue, NULL, NULL, NULL, NULL);
	RegGetValueW (HKEY_LOCAL_MACHINE, TEXT("HARDWARE\\DESCRIPTION\\System\\BIOS"),
		TEXT("BIOSVendor"), RRF_RT_ANY, NULL, achValue, &cchValue);
	return achValue;
}
